<script setup lang="ts">
    import { graphql } from "./../../gql/index";
    import { computed } from "vue";
    import useNavigationStore from "./../../stores/navigation";
    import { useQuery } from "@vue/apollo-composable";
    import { useRouter } from "vue-router";
    import { DynamicRoutePaths } from "../../plugins/router";

    const router = useRouter();
    const navigationStore = useNavigationStore();

    // current events
    const instructorQueryVariables = computed(() => {
        return {
            id: navigationStore.instructorId,
        };
    });
    const instructorEventsQuery = graphql(`
        query InstructorEventsAndZirkelQuery($id: Uuid = "00000000-0000-0000-0000-000000000000") {
            instructor(id: $id) {
                id
                extensions {
                    id
                    event {
                        id
                        name
                        year
                    }
                    zirkel {
                        id
                        name
                        event {
                            year
                            name
                            id
                        }
                    }
                }
            }
        }
    `);
    const { result: resultInstructorEvents } = useQuery(instructorEventsQuery, instructorQueryVariables, {
        fetchPolicy: "cache-and-network",
    });
    const participatedEvents = computed(() => {
        let extensions = resultInstructorEvents.value?.instructor!.extensions! ?? [];
        let res = [] as { name: string; id: string; year: number }[];

        extensions.forEach((extension) => {
            res.push({
                name: (extension.event?.name ?? "") + " (" + (extension.event?.year ?? "") + ")",
                year: extension.event?.year ?? 0,
                id: extension.event?.id ?? "",
            });
        });

        res = res.sort((a, b) => {
            const year = b.year - a.year;
            if (year != 0) {
                return year;
            }
            return a.name.localeCompare(b.name);
        });

        return res;
    });
    const participatedZirkel = computed(() => {
        let extensions = resultInstructorEvents.value?.instructor!.extensions! ?? [];
        let res = [] as { name: string; eventName: string; id: string; eventId: string; year: number }[];

        extensions.forEach((extension) => {
            (extension.zirkel ?? []).forEach((zirkel) => {
                res.push({
                    name: zirkel.name ?? "",
                    eventName: (zirkel.event?.name ?? "") + " (" + (zirkel.event?.year ?? "") + ")",
                    year: zirkel.event?.year ?? 0,
                    eventId: zirkel.event?.id ?? "",
                    id: zirkel.id,
                });
            });
        });

        res = res.sort((a, b) => {
            const year = b.year - a.year;
            if (year != 0) {
                return year;
            }
            const event = a.eventName.localeCompare(b.eventName);
            if (event != 0) {
                return event;
            }
            return a.name.localeCompare(b.name);
        });

        return res;
    });
</script>

<template>
    <v-row class="v-col-12">
        <div class="v-col-lg-6 v-col-12">
            <h2 class="mb-5">Teilnahme an Veranstaltungen</h2>
            <h3 class="mb-5">(Allgemeiner Zirkelleiter)</h3>
            <v-row class="v-col-12">
                <v-table style="width: 100%" @touchstart.native.stop @touchmove.native.stop @touchend.native.stop>
                    <tbody>
                        <tr v-for="event in participatedEvents">
                            <td>{{ event.name }}</td>
                            <td>
                                <v-btn
                                    size="small"
                                    @click="
                                        {
                                            navigationStore.eventId = event.id;
                                            router.push({ name: DynamicRoutePaths.EventAndZirkelDetails });
                                        }
                                    "
                                >
                                    <template v-slot:prepend> <span class="material-symbols-outlined"> search </span></template>
                                    anzeigen
                                </v-btn>
                            </td>
                            <td>
                                <v-btn size="small" @click="navigationStore.instructorViewTab = event.id">
                                    <template v-slot:prepend> <span class="material-symbols-outlined"> search </span></template>
                                    Eigene Details
                                </v-btn>
                            </td>
                        </tr>
                    </tbody>
                </v-table>
            </v-row>
        </div>
        <div class="v-col-lg-6 v-col-12">
            <h2 class="mb-5">Zirkel-Leitungen</h2>
            <h3 class="mb-5">(Semi-)Alleiniger Zirkelleiter</h3>
            <v-row class="v-col-12">
                <v-table style="width: 100%" @touchstart.native.stop @touchmove.native.stop @touchend.native.stop>
                    <tbody>
                        <tr v-for="zirkel in participatedZirkel">
                            <td>{{ zirkel.name }}</td>
                            <td>{{ zirkel.eventName }}</td>
                            <td>
                                <v-btn
                                    size="small"
                                    @click="
                                        {
                                            navigationStore.zirkelId = zirkel.id;
                                            router.push({ name: DynamicRoutePaths.EventAndZirkelDetails });
                                        }
                                    "
                                >
                                    <template v-slot:prepend> <span class="material-symbols-outlined"> search </span></template>
                                    Zirkel Anzeigen
                                </v-btn>
                            </td>
                            <td>
                                <v-btn
                                    size="small"
                                    @click="
                                        {
                                            navigationStore.instructorViewTab = zirkel.eventId;
                                            navigationStore.instructorSubTab = 'zirkel';
                                        }
                                    "
                                >
                                    <template v-slot:prepend> <span class="material-symbols-outlined"> search </span></template>
                                    Event Zirkel anzeigen
                                </v-btn>
                            </td>
                        </tr>
                    </tbody>
                </v-table>
            </v-row>
        </div>
    </v-row>
</template>
